/*#include <windows.h>
#include <stdio.h>
#include <DSound.h>
#include <new>

#define REC_FREQUENCY	44100
#define REC_BITS		16
#define REC_CHANNELS	2	// Non cambiare!
#define REC_BYTEPERSECOND	REC_FREQUENCY * (REC_BITS / 8) * REC_CHANNELS
#define REC_SECONDS(X)	X * REC_BYTEPERSECOND

typedef struct _WAVESTRUCT{
	UCHAR ucId[4];		// "RIFF"
	UINT uFileLength;	// Lunghezza di tutto il file -8
	UCHAR ucFormat[4];	// "WAVE"
	UCHAR ucFmt[4];		// "fmt "
	UINT uSize;			// 16
	USHORT usAudioFmt;	// 1
	USHORT uChannels;
	UINT uSampleRate;			
	UINT uRate;			// uSampleRate * uChannels * (uBitsPS / 8)
	USHORT uBlockAlign;	// uChannels * (uBitsPS / 8)
	USHORT uBitsPS;
	UCHAR ucData[4];	// "data"
	UINT uDataSize;
} QWAVESTRUCT, *PQWAVESTRUCT;

BOOL CALLBACK DirectSoundCaptureEnum(LPGUID lpGuid, LPCSTR lpcstrDesc, LPCSTR lpcstrModule, LPVOID lpContext)
{
	OLECHAR buf[64] = L"(null)";
	LPGUID lpTemp = NULL;

	if (lpGuid){
		StringFromGUID2(*lpGuid, buf, 64);
		printf("%ls : %hs : %hs\n", buf, lpcstrDesc, lpcstrModule);
	}

	return 0;
}

BOOL QWriteWave(PCHAR filename, WAVEFORMATEX wfx, PBYTE data, UINT uLen, BOOL bAppend){
	QWAVESTRUCT qws;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwWritten, dwEOF;

	if(filename == NULL)
		return FALSE;

	if(bAppend == FALSE){
		memset((PBYTE)&qws, 0x00, sizeof(qws));
		memcpy(qws.ucId, "RIFF", 4);
		memcpy(qws.ucFormat, "WAVE", 4);
		memcpy(qws.ucFmt, "fmt ", 4);
		memcpy(qws.ucData, "data", 4);
		qws.uFileLength = uLen + sizeof(qws) - 8;
		qws.uSize = 16;
		qws.usAudioFmt = wfx.wFormatTag;
		qws.uChannels = wfx.nChannels;
		qws.uSampleRate = wfx.nSamplesPerSec;
		qws.uBitsPS = wfx.wBitsPerSample;
		qws.uRate = qws.uSampleRate * qws.uChannels * (qws.uBitsPS / 8);
		qws.uBlockAlign = wfx.nBlockAlign;
		qws.uDataSize = uLen;

		hFile = CreateFile(filename, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

		int ciao;
		ciao = GetLastError();

		if(hFile == INVALID_HANDLE_VALUE)
			return FALSE;

		if(!WriteFile(hFile, (PBYTE)&qws, sizeof(qws), &dwWritten, NULL)){
			CloseHandle(hFile);
			return FALSE;
		}

		if(dwWritten != sizeof(qws)){
			CloseHandle(hFile);
			return FALSE;
		}

		if(!WriteFile(hFile, data, uLen, &dwWritten, NULL)){
			CloseHandle(hFile);
			return FALSE;
		}

		if(dwWritten != uLen){
			CloseHandle(hFile);
			return FALSE;
		}
	}else{
		hFile = CreateFile(filename, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		int ciao;
		ciao = GetLastError();
		if(hFile == INVALID_HANDLE_VALUE)
			return FALSE;

		SetFilePointer(hFile, 0, NULL, FILE_END);

		if(!WriteFile(hFile, data, uLen, &dwWritten, NULL)){
			CloseHandle(hFile);
			return FALSE;
		}

		if(dwWritten != uLen){
			CloseHandle(hFile);
			return FALSE;
		}

		dwEOF = SetFilePointer(hFile, 0, NULL, FILE_END);
		SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

		// Aggiorna l'header con le nuove informazioni
		memset((PBYTE)&qws, 0x00, sizeof(qws));
		memcpy(qws.ucId, "RIFF", 4);
		memcpy(qws.ucFormat, "WAVE", 4);
		memcpy(qws.ucFmt, "fmt ", 4);
		memcpy(qws.ucData, "data", 4);
		qws.uFileLength = dwEOF - 8;
		qws.uSize = 16;
		qws.usAudioFmt = wfx.wFormatTag;
		qws.uChannels = wfx.nChannels;
		qws.uSampleRate = wfx.nSamplesPerSec;
		qws.uBitsPS = wfx.wBitsPerSample;
		qws.uRate = qws.uSampleRate * qws.uChannels * (qws.uBitsPS / 8);
		qws.uBlockAlign = wfx.nBlockAlign;
		qws.uDataSize = dwEOF - sizeof(qws);

		if(!WriteFile(hFile, (PBYTE)&qws, sizeof(qws), &dwWritten, NULL)){
			CloseHandle(hFile);
			return FALSE;
		}

		if(dwWritten != sizeof(qws)){
			CloseHandle(hFile);
			return FALSE;
		}
	}

	CloseHandle(hFile);
	return TRUE;
}

int main(int argc, char *argv[])
{
	HRESULT hr;
	BOOL						bAppend = FALSE;
	UINT						uTimes = 0;
	PBYTE						pBuffer = NULL;
	DWORD						dwStatus, dwFirstPart, dwFirstPartBytes;
	DWORD						dwSecondPart, dwSecondPartBytes, dwReadSize = 0;
	DWORD						dwCaptureCursorCapturePosition, dwCaptureCursorReadPosition;
	DWORD						dwLastCaptureCursorReadPosition = 0, dwCaptureStreamPosition = 0;
	DSCBUFFERDESC               dscbd;
	DSCCAPS						dscsettings;
	LPDIRECTSOUNDCAPTUREBUFFER  pDSCB;
	LPDIRECTSOUNDCAPTURE8		pDSC;
	LPDIRECTSOUNDCAPTUREBUFFER8 ppDSCB8 = NULL;
	LPDIRECTSOUNDBUFFER			lpDSB = NULL;
	WAVEFORMATEX                wfx =
	{WAVE_FORMAT_PCM, REC_CHANNELS, REC_FREQUENCY, REC_BYTEPERSECOND, 4, REC_BITS, 0};
	// wFormatTag, nChannels, nSamplesPerSec, nAvgBytesPerSec,
	// nBlockAlign, wBitsPerSample, cbSize

	memset(&dscsettings, 0, sizeof(dscsettings));
	dscsettings.dwSize = sizeof(DSCCAPS);

	memset(&dscbd, 0, sizeof(dscbd));
	dscbd.dwSize = sizeof(DSCBUFFERDESC);
	dscbd.dwFlags = DSCBCAPS_WAVEMAPPED;
	dscbd.dwBufferBytes = REC_SECONDS(4);
	dscbd.dwReserved = 0;
	dscbd.lpwfxFormat = &wfx;
	dscbd.dwFXCount = 0;
	dscbd.lpDSCFXDesc = NULL;

	hr = DirectSoundCaptureCreate8(NULL, &pDSC, NULL);

	if(FAILED(hr))
		return hr;

	hr = pDSC->GetCaps(&dscsettings);

	if(FAILED(hr))
		return hr;

	// Se non e' supportata la cattura multipla, esci.
	if(!(dscsettings.dwFlags & DSCCAPS_MULTIPLECAPTURE))
		return FALSE;

	hr = pDSC->CreateCaptureBuffer(&dscbd, &pDSCB, NULL);

	if(FAILED(hr))
		return hr;

	hr = pDSCB->QueryInterface(IID_IDirectSoundCaptureBuffer8, (LPVOID*)&ppDSCB8);

	if(FAILED(hr))
		return hr;

	pDSCB->Release();  

	hr = ppDSCB8->Start(DSCBSTART_LOOPING);

	if(FAILED(hr))
		return hr;

	hr = ppDSCB8->GetStatus(&dwStatus);

	if(FAILED(hr) || dwStatus != (DSCBSTATUS_CAPTURING | DSCBSTATUS_LOOPING))
		return hr;

	while(uTimes != 30){
		Sleep(200);

		ppDSCB8->GetCurrentPosition(&dwCaptureCursorCapturePosition, &dwCaptureCursorReadPosition);  

		// Se sono stati catturati dei byte
		if(dwCaptureCursorReadPosition != dwLastCaptureCursorReadPosition){  
			if(dwCaptureCursorReadPosition > dwLastCaptureCursorReadPosition){  // Se siamo avanti
				dwReadSize = dwCaptureCursorReadPosition - dwLastCaptureCursorReadPosition;  
				dwCaptureStreamPosition += dwReadSize;  
			}else{ // Se siamo indietro sul buffer circolare
				dwReadSize = dwCaptureCursorReadPosition + dscbd.dwBufferBytes - dwLastCaptureCursorReadPosition;  
				dwCaptureStreamPosition += dwReadSize;  
			}  
		}  

		if(dwReadSize > 0){
			// Lock the capture buffer down  
			if(FAILED(hr = ppDSCB8->Lock(dwLastCaptureCursorReadPosition, dwReadSize, 
				(LPVOID *)&dwFirstPart, &dwFirstPartBytes, (LPVOID *)&dwSecondPart, &dwSecondPartBytes, 0L))){ 
				ppDSCB8->Stop();
				return 0;
			}

			pBuffer = new(std::nothrow) BYTE[dwFirstPartBytes + 1];

			if(pBuffer == NULL){
				ppDSCB8->Stop();
				return 0;
			}

			memcpy(pBuffer, (PBYTE)dwFirstPart, dwFirstPartBytes);

			if(FAILED(hr = ppDSCB8->Unlock((LPVOID *)dwFirstPart, dwFirstPartBytes, (LPVOID *)dwSecondPart, dwSecondPartBytes))){
				ppDSCB8->Stop();
				delete[] pBuffer;
				return 0;  
			} 

			// XXX Il buffer deve restare lockato il MENO possibile, sarebbe una buona idea quella
			// di memcpy-are il contenuto di dwFirstPart in un buffer grande dwFirstPartBytes,
			// unlockare il buffer e poi scriverlo su disco
			if(QWriteWave("c:\\rec01.wav", wfx, pBuffer, dwFirstPartBytes, bAppend) == FALSE){
				ppDSCB8->Stop();
				delete[] pBuffer;
				return 0;
			}

			delete[] pBuffer;
		}

		// save our position for next read  
		dwLastCaptureCursorReadPosition = dwCaptureCursorReadPosition; 

		bAppend = TRUE;
		uTimes++;
	}


		hr = ppDSCB8->Lock(0, 0, (LPVOID *)&dwFirstPart, &dwFirstPartBytes, (LPVOID *)&dwSecondPart, &dwSecondPartBytes, DSCBLOCK_ENTIREBUFFER);

		if(FAILED(hr))
			return hr;

		pSound = new(std::nothrow) BYTE[dwFirstPartBytes];

		if(pSound == NULL)
			return 0;

		memcpy(pSound, (PBYTE)dwFirstPart, dwFirstPartBytes);

		hr = ppDSCB8->Unlock((LPVOID *)dwFirstPart, dwFirstPartBytes, NULL, NULL);

		if(FAILED(hr))
			return hr;

		ppDSCB8->Stop();

		if(QWriteWave("c:\\test1.wav", wfx, pSound, dwFirstPartBytes, bAppend) == FALSE){
			delete[] pSound;
			return 0;
		}

		bAppend = TRUE;
		uTimes++;
	}

	ppDSCB8->Stop();

	return hr;
}

*/